class HashMap
  def initialize(&key_generator_prc)
    key_generator_prc ||= Proc.new { |val| val.hash }
    @cache = {}
    @key_generator_prc = key_generator_prc
  end

  def create_key(val)
    @key_generator_prc.call(val)
  end

  def add(val)
    key = create_key(val)
    @cache[key] = val
  end

  def remove(val)
    key = create_key(val)
    @cache.delete(key)
  end

  def update(val)
    add(val)
  end

  def include?(val)
    key = create_key(val)
    @cache.include?(key)
  end

  def [](key)
    @cache[key]
  end

  def length
    @cache.length
  end

  def each
    @cache.each { |key, value| yield key, value }
  end
end
