class LinkedListNode
  attr_reader :prev, :next
  attr_accessor :value

  def initialize(value = nil)
    raise "Error in LinkedListNode::new - value is a LinkedListNode instance" if value.class == LinkedListNode

    @value = value
    @prev = nil
    @next = nil
  end

  def prev=(other_node)
    _validate_node(other_node, :prev)
    @prev = other_node
  end

  def next=(other_node)
    _validate_node(other_node, :next)
    @next = other_node
  end

  private

  def _validate_node(node, function_name)
    raise "Error in LinkedListNode##{function_name} - other_node is not a LinkedListNode instance" unless node.class == LinkedListNode || node.nil?
  end
end
